<!--- :  batch script with hybrid vbs code ---
:: Created by MP and rys70 based on WOTOK of Krakatoa@MDL
:: Office 365 or 2019 on Windows 7 and up

@echo off
chcp 1255>nul
:: set _365=1 -> install Office 365 + Mondo license
:: set _365=0 -> install Office 2019 ProPlus
set "_365=0"
:: set _mondo=1 -> mondo license in seperate process
:: set _mondo=0 -> mondo license in same process
:: set _mondo=- -> install without mondo license
set "_mondo=1"

::Detect help request
if /i "%1"=="-h" goto :help
if /i "%1"=="-help" goto :help

::Check self elevating run 
if "%~1"=="admin" shift /1 & goto :selfadmincheck
::Check admin permissions 
reg query "HKU\S-1-5-19" >NUL 2>&1 && goto :admin

::Running this script elevated
cscript //nologo "%~f0?.wsf" //job:ADMIN "/c" "chr(34)%~0chr(34)" "admin" "%*" & exit /b

::Check admin permissions in self elevated run
:selfadmincheck
reg query "HKU\S-1-5-19" >NUL 2>&1 && goto :admin
echo Error self elevating the script, please run as admin manually.
echo Press any key to exit.
pause >nul
exit /b
 
:admin
color 1F
pushd "%~dp0"
set "ctrConfig=HKLM\SOFTWARE\Microsoft\Office\ClickToRun\Configuration"
set "CTRF=%CommonProgramFiles%\Microsoft Shared\ClickToRun"
set "cdnms=http://officecdn.microsoft.com/pr"
set "cdn=%cdnms%"
for /F %%C in ('copy /Z "%~f0" nul') do set "CR=%%C"
for /F %%C in ('echo prompt $H ^| cmd') do set "BS=%%C"
set setp1=set /p="
set setp2="<nul
set "SPACES=                                                                   "
set "delay=call :waitFor 60
if exist "%programfiles(x86)%" (set "bitos=64") else (set "bitos=32")
setlocal EnableExtensions
setlocal EnableDelayedExpansion

if /i "%1"=="goto" if not "%2"=="" goto :%2

::save arguments from filename to variables
for /f "tokens=1-7 delims= " %%G in ("%~n0") do (
    if not "%%J"=="" call :Automode %%H %%I %%J %%K %%L %%M  
    )

::save arguments to variables
:arg
    if not "%1"=="" call :setarg %1 %2
    if "%args%"=="x" goto :eof 
    if not "%1"=="" shift /1
    if not "%1"=="" if "%args%"=="2" shift /1
    if not "%1"=="" goto :arg

::set auto mode
if "%Auto%"=="Download" set "mode=Download Office" & goto :Download
if "%Auto%"=="Online" set "mode=Install Office Online" & goto :InstallOnline
if "%Auto%"=="Offline" set "mode=Install Office Offline" & goto :InstallOffline

:MainMenu
    setlocal
    cls
    title Office Toolkit
    pushd "%~dp0"
    echo.
    echo ============================================================
    echo  Office Toolkit
    echo ============================================================
    echo.
    echo  [ 1 ] Install Online
    echo  [ 2 ] Download
    echo  [ 3 ] Install Offline
    echo  [ 4 ] Automation Script Configurator
    echo  [ X ] EXIT
    echo.
    CHOICE /C 1234X /M "Enter your choice:"
    if %errorlevel%==1 set "mode=Install Office Online" & goto :InstallOnline
    if %errorlevel%==2 set "mode=Download Office" & goto :Download
    if %errorlevel%==3 set "mode=Install Office Offline" & goto :InstallOffline
    if %errorlevel%==4 set "mode=Automation Script Configurator" & goto :createmode
    if %errorlevel%==5 goto :EXIT
    
:InstallOnline
    ping -n 1 google.com >nul 2>&1 || (echo No connection to internet.& pause & (if not "%Auto%"=="" goto :eof) & endlocal & goto :MainMenu)
    call :id
    if not "%A_ver%"=="" (
        set "ver=%A_ver%"
        ) 
    if /i "%ver:~0,1%"=="n" set "ver=" 
    if "%ver%"=="" (call :check %id%)
    call :connection
    set "check=" & if "%check%" lss "10000" (echo Problem connecting to Microsoft servers. & pause & (if not "%Auto%"=="" goto :eof) & endlocal & goto :MainMenu)
    call :Bit
    call :Lang
    set "cdnbaseurl=%cdnms%/%id%"
    set "baseurl=%cdnbaseurl%"
    set "files=temp"
    goto :InstallFinal
    
:InstallOffline
    call :id
    set "c=0"
    set "choice="
    if exist Office\Data for /f %%D in ('dir /a:d  /o:-n /b Office\Data\') do (set /a c+=1 && set "i_ver!c!=%%D")
    if %c%==0 (echo Version not exist.& pause & (if not "%Auto%"=="" goto :eof) & endlocal & goto :MainMenu)
    if %c%==1 (set "ver=!i_ver1!" && goto :offlinebit)
    if not "%A_ver%"=="" (
        set "ver=!i_ver%A_ver%!"
        if "!ver!"=="" set "ver=%A_ver%"
        goto :offlinebit
        ) 
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version.
    for /L %%k in (1,1,%c%) do (
    set choice=!choice!%%k
    echo [ %%k ] !i_ver%%k!)
    echo.
    if %c% gtr 9 call :menugtr9 ver
    if %c% lss 10 call :menulss10 ver
    
    :offlinebit
    if "%ver%"=="" set "A_ver=" && echo Error&&pause&&goto :InstallOffline
    set "c=0"
    set "choice="
    if exist Office\Data\%ver% for /f "tokens=2 delims=.x" %%D in ('dir /a /o:-n /b Office\Data\%ver%\stream.x*.x-none.dat') do (set /a c+=1 && If %%D==86 (set "i_bit!c!=32") else (set "i_bit!c!=%%D"))
    if %c%==0 echo Error.&& set "A_ver=" &&pause&&goto :InstallOffline
    if %bitos%==32 (
        set "bit=32"
        if not exist Office\Data\%ver%\stream.x86.x-none.dat (
            cls
            echo.
            echo ============================================================
            echo  %mode%
            echo ============================================================
            echo.
            echo Version: %ver%
            echo Bit.
            echo Your system is %bitos%bit.
            echo 32bit version not exist.
            echo.
            echo Press any key to return to main menu.& pause >nul & endlocal & goto :MainMenu
            )
        )
    
    if not "%bit%"=="" goto :offlinearch
    if %c%==1 (set "bit=!i_bit1!" && goto :offlinearch)
    if not "%A_bit%"=="" (
        set "bit=!i_bit%A_bit%!"
        if "!bit!"=="" set "bit=%A_bit%" 
        goto :offlinearch
        ) 
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit.
    echo Your system is %bitos%bit.
    echo The recommended version is 32bit even for 64bit systems.
    echo.
    echo Select bit version.
    
    FOR /L %%k in (1,1,%c%) do (
    set choice=!choice!%%k
    echo [ %%k ] !i_bit%%k!)
    echo.
    if %c% gtr 9 call :menugtr9 bit
    if %c% lss 10 call :menulss10 bit
    
    :offlinearch
    if "%bit%"=="" set "A_bit=" && echo Error&&pause&&goto :offlinebit
    if %bit%==32 (set arch=86)
    if %bit%==64 (set arch=64)
    if "%arch%"=="" set "bit=" & set "A_bit=" && echo Error&&pause&&goto :offlinebit
    
    :offlinelang
    for /f "tokens=3 delims=." %%D in ('dir /a /o:n /b Office\Data\%ver%\stream.x%arch%.*.dat') do (If not %%D==x-none (set /a offlinelangc+=1 & set "offlinelang=!offlinelang!%%D_"))
    call :Lang
    
    :offlineset
    set "cdnbaseurl=%cdnms%/%id%"
    set "baseurl=%~dp0"
    set "baseurl=%baseurl:~0,-1%"
    set "files=Office\Data\%ver%"
    
:InstallFinal
    call :product all
    call :excludedapps
    if not "%Auto%"=="" goto :InstallStart
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang: %ln%
    echo Product: %product%%productvisio%%productproject%
    echo %Included%
    echo.
    echo Install Office CommandLine
    echo "%CTRF%\OfficeClickToRun.exe"^
     cdnbaseurl.16=%cdnbaseurl%^
     baseurl.16="%baseurl%"^
     version.16=%ver%^
     platform=x%arch%^
     culture=%lang1%^
     displaylevel=True^
     productstoadd=%product%.16_%lang%_x-none^%Projectpro1%%Visiopro1%
     %excludedapps%^
     %excludedappsVisio%^
     %excludedappsProject%^
     deliverymechanism=%id%
    echo.
    echo  [ 1 ] Start install
    echo  [ 2 ] return to main menu
    echo.
    CHOICE /C 12 /M "Enter your choice:"
    if %ERRORLEVEL%==1 goto :InstallStart
    if %ERRORLEVEL%==2 endlocal & goto :MainMenu
    
    :InstallStart
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang: %ln%
    echo Product: %product%%productvisio%%productproject%
    echo %Included%
    echo.
    if "%_365%"=="1" (
        echo Do not close this window until installation is finished.
        echo.
        )
    if not exist "%CTRF%" md "%CTRF%"
    if not exist "%CTRF%\OfficeClickToRun.exe" (
        if %files%==temp if not exist %files%\i%bitos%0.cab if not exist %files%\i%bitos%%lcid1%.cab (
            if not exist temp (md temp >nul 2>&1)
            call :aria2c i%bitos%0.cab -x1
            call :aria2c i%bitos%%lcid1%.cab -x1
            goto :InstallStart
            )
        echo Copying installer...
        expand %files%\i%bitos%0.cab -F:* "%CTRF%" >nul 2>&1
        expand %files%\i%bitos%%lcid1%.cab -F:* "%CTRF%" >nul 2>&1
        if exist temp (rd /S /Q temp >nul 2>&1)
        goto :InstallStart
        )
    if "%_365%"=="1" if "%_mondo%"=="1" cscript //nologo "%~f0?.wsf" //job:HIDDEN "/c" "chr(34)%~0chr(34)" "goto mondo"
    
     start "" "%CTRF%\OfficeClickToRun.exe"^
     cdnbaseurl.16=%cdnbaseurl%^
     baseurl.16="%baseurl%"^
     version.16=%ver%^
     platform=x%arch%^
     culture=%lang1%^
     displaylevel=True^
     productstoadd=%product%.16_%lang%_x-none^%Projectpro1%%Visiopro1%
     %excludedapps%^
     %excludedappsVisio%^
     %excludedappsProject%^
     deliverymechanism=%id%
    set check=wmic process where "Caption like 'OfficeClickToRun.exe'" get CommandLine /format:textvaluelist ^| find /i "%product%" ^>nul ^|^| goto :pw3
    call :PleaseWait "Installing Office, please wait"
    
    for /f "tokens=3* skip=1 delims= " %%l in ('reg query "HKCU\Software\Microsoft\Office\16.0\common\LanguageResources" /reg:%bitos% /v "UIFallbackLanguages"') do set uilang=%%l
    echo %uilang% | find /i "%lang1%" > nul || echo Install failed.& if not "%Auto%"=="" (timeout 5 & goto :Exit) else (echo.& echo Press any key to return to main menu.& pause>nul & endlocal & goto :MainMenu)
    if "%lang1%"=="%langos%" goto :afterlanginreg
    if "%uilang:~12%"=="" goto :afterlanginreg
    call set uilang=%%uilang:%lang1%=%%
    set uilang=%uilang:;;=;%
    if "%uilang:~0,1%"==";" set uilang=%uilang:~1%
    if "%uilang:~-1%"==";" set uilang=%uilang:~0,-1%
    reg add "HKCU\Software\Microsoft\Office\16.0\common\LanguageResources" /reg:%bitos% /v "UIFallbackLanguages" /t REG_SZ /d "%lang1%;%uilang%" /f > nul
    
    :afterlanginreg
    if "%_365%"=="1" if "%_mondo%"=="0" call :mondo
    if "%_365%"=="1" if "%_mondo%"=="1" call :showmondo
    echo Office installation complete. You may now close this window.
    if not "%Auto%"=="" (timeout 5&&goto :Exit)
    echo.
    echo Press any key to return to main menu.& pause >nul & endlocal & goto :MainMenu
    
:Download
    ping -n 1 google.com >nul 2>&1 || (echo No connection to internet.& pause & (if not "%Auto%"=="" goto :eof) & endlocal & goto :MainMenu)
    call :id
    set "c=0"
    set "choice="
    if exist Office\Data for /f %%D in ('dir /a:d /o-n /b Office\Data\') do (set /a c+=1 && set "i_ver!c!=%%D")
    if not "%A_ver%"=="" (
        set "ver=!i_ver%A_ver%!"
        if "!ver!"=="" set "ver=%A_ver%"
        ) 
    if not "%ver%"=="" goto :Download1
    if %c%==0 goto :Download1
    call :check
    if "%ver%"=="%i_ver1%" (set "q_ver=echo You already have the newest exist version.") else (set "q_ver=echo You haven't the newest exist version.")
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Exist downloaded Office files.
    %q_ver%
    echo.
    echo  [ 1 ] Download newest version
    echo  [ 2 ] Add files to exist version
    echo.
    CHOICE /C 12 /M "Enter your choice:"
    if %ERRORLEVEL%==1 goto :Download1
    if "%c%"=="1" (set "ver=!i_ver1!" && goto :Download1)
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    for /L %%k in (1,1,%c%) do (
    set choice=!choice!%%k
    echo [ %%k ] !i_ver%%k!)
    if %c% gtr 9 call :menugtr9 ver
    if %c% lss 10 call :menulss10 ver

    :Download1
    if /i "%ver:~0,1%"=="n" set "ver="
    if "%ver%"=="" (call :check %id%)
    call :connection
    set "check=" & if "%check%" lss "10000" (cls & echo Problem connecting to Microsoft servers.& pause & (if not "%Auto%"=="" goto :eof) & endlocal & goto :MainMenu)
    call :Bit
    call :Lang
    if not "%Auto%"=="" goto :DownloadStart
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang: %ln%
    echo.
    echo  [ 1 ] Start download
    echo  [ 2 ] return to main menu
    echo.
    CHOICE /C 12 /M "Enter your choice:"
    if %ERRORLEVEL%==2 endlocal & goto :MainMenu
    
    :DownloadStart
    if not exist "Office\Data\%ver%" (md "Office\Data\%ver%" >nul 2>&1)
    set "files=Office\Data\%ver%"
    call :aria2c  stream.x%arch%.x-none.dat -x4
    call :aria2c s%bit%0.cab -x4
    call :aria2c i640.cab -x1
    if %bit%==32 call :aria2c i320.cab -x1
    set "downloadc="

    :downloadlang
    set /a downloadc+=1
    if "!lang%downloadc%!"=="" set "downloadc=" & goto :afterdownload
    call :aria2c stream.x%arch%.!lang%downloadc%!.dat -x4
    call :aria2c s%bit%!lcid%downloadc%!.cab -x4
    call :aria2c i64!lcid%downloadc%!.cab -x1
    if %bit%==32 call :aria2c i32!lcid%downloadc%!.cab -x1
    goto :downloadlang

    :afterdownload
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang: %ln%
    echo.
    echo Download complete.
    if not "%Auto%"=="" (
        if /i "%A_exclude%"=="X" timeout 5&&goto :Exit
        if %bitos%==32 if %bit%==64 echo Your system doesn't support 64bit program&&pause&&endlocal&goto :Exit
        set "Auto=offline"&& set "mode=Install Office Offline"&& goto :offlineset
        )
    echo.
    if %bitos%==32 if %bit%==64 echo Press any key to return to main menu& pause >nul & endlocal & goto :MainMenu
    echo  [ 1 ] Install with current download set
    echo  [ 2 ] return to main menu
    echo.
    CHOICE /C 12 /M "Enter your choice:"
    if %ERRORLEVEL%==1 set "mode=Install Office Offline"&& goto :offlineset
    if %ERRORLEVEL%==2 endlocal & goto :MainMenu
    
:createmode
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Select operation mode.
    echo [ 0 ] Prompt user
    echo [ 1 ] Install Online
    echo [ 2 ] Download
    echo [ 3 ] Install Offline
    echo.
    CHOICE /C 0123 /M "Enter your choice:"
    if %errorlevel%==1 set "iA_mode= 0" & set "iA_mode2=(Prompt user)" & set "iA_ver= 0" & goto :createbit
    if %errorlevel%==2 set "iA_mode= N" & set "iA_mode2=(Install Online)" & goto :createver
    if %errorlevel%==3 set "iA_mode= D" & set "iA_mode2=(Download)" & goto :createver
    if %errorlevel%==4 set "iA_mode= F" & set "iA_mode2=(Install Offline)" & goto :createver

    :createver
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo mode:%iA_mode% %iA_mode2%
    echo.
    echo Select version.
    if not "%iA_mode%"==" F" (
        echo for newest version on server, enter 'N' or 'Newest'.
        echo For other version enter specific full version no.
        ) 
    if "%iA_mode%"==" D" (
        echo or enter no. of downloaded version:
        echo For newest existing version, enter 1.
        echo For older versions, enter corresponding number
        echo ^(2 for 2nd to newest, 3 for 3rd, etc^).
        )
    if "%iA_mode%"==" F" (
        echo For newest existing version, enter 1.
        echo For older versions, enter corresponding number
        echo ^(2 for 2nd to newest, 3 for 3rd, etc^).
        echo you can also enter specific full version no.
        echo To prompt user enter 0.
        echo If only one version exists, it will be selected 
        echo regardless of number you've entered.
        )
    echo.
    set userinp=-
    set /p userinp=Enter your choice and press Enter: 
    if %userinp%==- goto :createver
    set "iA_ver= %userinp%"
    
    :createbit
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo.
    echo Select bit.
    echo Your system is %bitos%bit.
    echo The recommended version is 32bit even for 64bit systems.
    echo [ 0 ] Prompt user
    echo [ 1 ] 32
    echo [ 2 ] 64
    echo.
    CHOICE /C 012 /M "Enter your choice:"
    if %ERRORLEVEL%==1 set "iA_bit= 0" & set "iA_bit2=(Prompt user)"
    if %ERRORLEVEL%==2 set "iA_bit= 32" & set "iA_bit2=(32bit)"
    if %ERRORLEVEL%==3 set "iA_bit= 64" & set "iA_bit2=(64bit)"
    
    :createlang
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo Bit:%iA_bit% %iA_bit2%
    echo.
    echo Select language.
    echo [ 0 ] Prompt user
    echo [ 1 ] Hebrew
    echo [ 2 ] English
    echo [ 3 ] Russian
    echo [ 4 ] French
    echo [ 5 ] Spanish
    echo [ 6 ] multiple languages
    echo.
    CHOICE /C 0123456 /M "Enter your choice:"
    if %ERRORLEVEL%==1 set "iA_lang= 0" & set "iA_lang2=Prompt user"
    if %ERRORLEVEL%==2 set "iA_lang= H" & set "iA_lang2=Hebrew"
    if %ERRORLEVEL%==3 set "iA_lang= E" & set "iA_lang2=English"
    if %ERRORLEVEL%==4 set "iA_lang= R" & set "iA_lang2=Russian"
    if %ERRORLEVEL%==5 set "iA_lang= F" & set "iA_lang2=French"
    if %ERRORLEVEL%==6 set "iA_lang= S" & set "iA_lang2=Spanish"
    if %ERRORLEVEL%==7 goto :createmultilang
    goto :createex
    
    :createmultilang
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo Bit:%iA_bit% %iA_bit2%
    echo.
    echo Select the default language first.
    echo [ 1 ] Hebrew
    echo [ 2 ] English
    echo [ 3 ] Russian
    echo [ 4 ] French
    echo [ 5 ] Spanish
    echo.
    CHOICE /C 12345 /M "Enter your choice:"
    if %ERRORLEVEL%==1 set "iA_lang= H" & set "iA_lang2=Hebrew"
    if %ERRORLEVEL%==2 set "iA_lang= E" & set "iA_lang2=English"
    if %ERRORLEVEL%==3 set "iA_lang= R" & set "iA_lang2=Russian"
    if %ERRORLEVEL%==4 set "iA_lang= F" & set "iA_lang2=French"
    if %ERRORLEVEL%==5 set "iA_lang= S" & set "iA_lang2=Spanish"

    :createmultilang2
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo Bit:%iA_bit% %iA_bit2%
    echo Lang:%iA_lang% (%iA_lang2%)
    echo.
    echo Select the next language.
    set "c="
    set "choice="
    For %%k in ("H:Hebrew" "E:English" "R:Russian" "F:French" "S:Spanish") do for /f "tokens=1,2 delims=:" %%l in ("%%~k")do (
    if "%iA_lang%"=="!iA_lang:%%l=!" (set /a c+=1 & set "langch!c!=%%l" & set "lnch!c!=%%m" & set "choice=!choice!!c!" & echo [ !c! ] %%m))
    set /a c+=1 & set "choice=%choice%!c!" & set "save=!c!" & echo [ !c! ] continue with current languages set 
    CHOICE /C %choice% /M "Enter your choice:"
    if %ERRORLEVEL%==%save% set "save=" & goto :createex
    set "iA_lang=%iA_lang%+!langch%ERRORLEVEL%!" & set "iA_lang2=%iA_lang2%+!lnch%ERRORLEVEL%!"
    if %c%==2 goto :createex 
    goto :createmultilang2
    
    :createex
    set "Word=yes" & set "iA_word=w" 
    set "Excel=yes" & set "iA_excel=e"
    set "PowerPoint=yes" & set "iA_powerpoint=p"
    set "Access=yes" & set "iA_access=a"
    set "Outlook=yes" & set "iA_outlook=l"
    set "OneDrive=no" & set "iA_onedrive="
    set "OneNote=no" & set "iA_onenote="
    set "Publisher=no" & set "iA_publisher="
    set "Lync=no" & set "iA_lync="
    set "Groove=no" & set "iA_groove="
    set "VisioPro=no" & set "iA_visiopro="
    set "ProjectPro=no" & set "iA_projectpro="
    if "%iA_mode2%"=="(Download)" (set "X=X") else (set "X=")

    :createexch
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo Bit:%iA_bit% %iA_bit2%
    echo Lang:%iA_lang% (%iA_lang2%)
    echo.
    if "%iA_mode2%"=="(Download)" (echo Select apps to install after download.) else (echo Select apps to install.)
    if "%iA_mode2%"=="(Download)" echo [ X ] Download without install
    echo [ 0 ] Prompt user
    echo [ 1 ] Default apps (W E P A L) set
    echo [ F ] All apps set
    echo [ W ] Word                  : %Word%
    echo [ E ] Excel                 : %Excel%
    echo [ P ] PowerPoint            : %PowerPoint%
    echo [ A ] Access                : %Access%
    echo [ L ] OutLook               : %Outlook%
    echo [ D ] OneDrive              : %OneDrive%
    echo [ N ] OneNote               : %OneNote%
    echo [ U ] Publisher             : %Publisher%
    echo [ S ] Skype For Business    : %Lync%
    echo [ O ] OneDrive For Business : %Groove%
    echo [ V ] Visio                 : %VisioPro%
    echo [ R ] Project               : %ProjectPro% 
    echo [ C ] Current apps set

    echo.
    CHOICE /C 01FWEPALDNUSOVRC%X% /M "Enter your choice:"
    if %ERRORLEVEL%==1 set "iA_ex= 0" & goto :createproduct
    if %ERRORLEVEL%==2 set "iA_ex= 1" & goto :createproduct
    if %ERRORLEVEL%==3 set "iA_ex= f" & goto :createproduct
    if %ERRORLEVEL%==4 if %Word%==no (set "Word=yes" & set "iA_word=w") else (set "Word=no" & set "iA_word=")
    if %ERRORLEVEL%==5 if %Excel%==no (set "Excel=yes" & set "iA_excel=e") else (set "Excel=no" & set "iA_excel=")
    if %ERRORLEVEL%==6 if %PowerPoint%==no (set "PowerPoint=yes" & set "iA_powerpoint=p") else (set "PowerPoint=no" & set "iA_powerpoint=")
    if %ERRORLEVEL%==7 if %Access%==no (set "Access=yes" & set "iA_access=a") else (set "Access=no" & set "iA_access=")
    if %ERRORLEVEL%==8 if %Outlook%==no (set "Outlook=yes" & set "iA_outlook=l") else (set "Outlook=no" & set "iA_outlook=")
    if %ERRORLEVEL%==9 if %OneDrive%==no (set "OneDrive=yes" & set "iA_onedrive=d") else (set "OneDrive=no" & set "iA_onedrive=")
    if %ERRORLEVEL%==10 if %OneNote%==no (set "OneNote=yes" & set "iA_onenote=n") else (set "OneNote=no" & set "iA_onenote=")
    if %ERRORLEVEL%==11 if %Publisher%==no (set "Publisher=yes" & set "iA_publisher=u") else (set "Publisher=no" & set "iA_publisher=")
    if %ERRORLEVEL%==12 if %Lync%==no (set "Lync=yes" & set "iA_lync=s") else (set "Lync=no" & set "iA_lync=")
    if %ERRORLEVEL%==13 if %Groove%==no (set "Groove=yes" & set "iA_groove=o") else (set "Groove=no" & set "iA_groove=")
    if %ERRORLEVEL%==14 if %VisioPro%==no (set "VisioPro=yes" & set "iA_visiopro=v") else (set "VisioPro=no" & set "iA_visiopro=")
    if %ERRORLEVEL%==15 if %ProjectPro%==no (set "ProjectPro=yes" & set "iA_projectpro=r") else (set "ProjectPro=no" & set "iA_projectpro=")
    if %ERRORLEVEL%==16 set "iA_ex= %iA_word%%iA_excel%%iA_powerpoint%%iA_access%%iA_outlook%%iA_onedrive%%iA_onenote%%iA_publisher%%iA_lync%%iA_groove%%iA_visio%%iA_projectpro%" & goto :createproduct
    if %ERRORLEVEL%==17 set "iA_ex= x" & goto :createproduct
    goto :createexch
    
    :createproduct
    if "%iA_ex%"==" " set "iA_ex= x"
    if "%iA_ex%"==" x" goto :createfinal
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo Bit:%iA_bit% %iA_bit2%
    echo Lang:%iA_lang% (%iA_lang2%)
    echo Apps:%iA_ex%
    echo.
    echo Select product.
    echo  [ 1 ] Office 365 ProPlus
    echo  [ 2 ] Office 2019 ProPlus Volume
    echo  [ 3 ] Office 2019 Professional Volume
    echo  [ 4 ] Office 2019 Home ^& Business Volume
    echo  [ 5 ] Office 2019 Home ^& student Volume
    echo  [ 6 ] Office 2019 ProPlus Retail
    echo  [ 7 ] Office 2019 Professional Retail
    echo  [ 8 ] Office 2019 Home ^& Business Retail
    echo  [ 9 ] Office 2019 Home ^& Student Retail

    echo.
    CHOICE /C 123456789 /M "Enter your choice:"
    if %ERRORLEVEL%==1 set "iA_pr= 365" & set "iA_pr2=(Office 365 ProPlus)"
    if %ERRORLEVEL%==2 set "iA_pr= 19" & set "iA_pr2=(Office 2019 ProPlus Volume)"
    if %ERRORLEVEL%==3 set "iA_pr= Professional19" & set "iA_pr2=(Office 2019 Professional Volume)"
    if %ERRORLEVEL%==4 set "iA_pr= HomeBusiness19" & set "iA_pr2=(Office 2019 Home ^& Business Volume)"
    if %ERRORLEVEL%==5 set "iA_pr= HomeStudent19" & set "iA_pr2=(Office 2019 Home ^& Student Volume)"
    if %ERRORLEVEL%==6 set "iA_pr= 19Retail" & set "iA_pr2=(Office 2019 ProPlus Retail)"
    if %ERRORLEVEL%==7 set "iA_pr= Professional19Retail" & set "iA_pr2=(Office 2019 Professional Retail)"
    if %ERRORLEVEL%==8 set "iA_pr= HomeBusiness19Retail" & set "iA_pr2=(Office 2019 Home ^& Business Retail)"
    if %ERRORLEVEL%==9 set "iA_pr= HomeStudent19Retail" & set "iA_pr2=(Office 2019 Home ^& Student Retail)"
    
    :createfinal
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo Bit:%iA_bit% %iA_bit2%
    echo Lang:%iA_lang% (%iA_lang2%)
    echo Apps:%iA_ex%
    if not "%iA_ex%"==" x" echo Product:%iA_pr% %iA_pr2%
    echo.
    echo The filename of the script will be "OfficeToolkit%iA_mode%%iA_ver%%iA_bit%%iA_lang%%iA_ex%%iA_pr%.bat"
    echo  [ 1 ] Create script file
    echo  [ 2 ] return to main menu
    echo.
    CHOICE /C 12 /M "Enter your choice:"
    if %ERRORLEVEL%==1 goto :createStart
    if %ERRORLEVEL%==2 endlocal & goto :MainMenu
    
    :createStart
    type "%~0" > "%~dp0OfficeToolkit%iA_mode%%iA_ver%%iA_bit%%iA_lang%%iA_ex%%iA_pr%.bat" 
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Mode:%iA_mode% %iA_mode2%
    echo Version:%iA_ver%
    echo Bit:%iA_bit% %iA_bit2%
    echo Lang:%iA_lang% (%iA_lang2%)
    echo Apps:%iA_ex%
    echo Product:%iA_pr% %iA_pr2%
    echo.
    echo The script "OfficeToolkit%iA_mode%%iA_ver%%iA_bit%%iA_lang%%iA_ex%%iA_pr%.bat" created.
    echo Press any key to return to main menu.& pause >nul & endlocal & goto :MainMenu
    
:id
    if "%id%"=="" set "id=492350F6-3A01-4F97-B9C0-C7C6DDF67D60"
    if /i %id%==492350F6-3A01-4F97-B9C0-C7C6DDF67D60 (set "channel=Production::CC"&&goto :eof)
    
:check
    echo Please wait a few moments...
    For /f usebackq^ tokens^=2^-4^ delims^=^" %%a in (`echo ^(New-Object System.Net.WebClient^).DownloadString^('https://mrodevicemgr.officeapps.live.com/mrodevicemgrsvc/api/v2/C2RReleaseData?audienceFFN^=%id%'^) ^| powershell -`) do (if /i "%%a"=="AvailableBuild" set "ver=%%c")
    goto :eof
    
:version
    if "%1"=="%2" (set "q_ver=echo You already have the newest exist version.") else ("q_ver=echo You haven't the newest exist version.")
    goto :eof

:connection
    echo (New-Object System.Net.WebClient).Downloadfile('%cdn%/%id%/Office/Data/%ver%/i321033.cab','%temp%\i321033.cab') | powershell -
    for %%f in ("%temp%\i321033.cab") do set "check=%%~zf" 
    del /f /q "%temp%\i321033.cab"
    goto :eof
      
:Bit
    if "%mode%"=="Install Office Online" if %bitos%==32 set "bit=32" & set "arch=86" & goto :eof
    if "%bit%"=="" if not "%A_bit%"=="" (set "ERRORLEVEL=%A_bit%" & goto :chbit)
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo bit.
    echo Your system is %bitos%bit.
    echo The recommended version is 32bit even for 64bit systems.
    echo.
    echo Select bit version.
    echo [ 1 ] 32
    echo [ 2 ] 64
    echo.
    CHOICE /C 12 /M "Enter your choice:"

    :chbit
    if %ERRORLEVEL%==1 set "bit=32" & set "arch=86"
    if %ERRORLEVEL%==2 set "bit=64" & set "arch=64"
    if %ERRORLEVEL%==32 set "bit=32" & set "arch=86"
    if %ERRORLEVEL%==64 set "bit=64" & set "arch=64"
    set "ERRORLEVEL="
    if "%bit%"=="" set "A_bit=" & goto :Bit
    goto :eof
    
:Lang
    for /f "tokens=2 delims=={}," %%G in ('wmic os get MUILanguages /Value') do (set "langos=%%~G")
    call :langtoln %langos% lnos
    if not "%langc%"=="" for /L %%n in (1,1,%langc%) do set "lang%%n="
    if not "%offlinelang%"=="" (set "possiblelang=%offlinelang%") else (set "possiblelang=he-il_en-us_ru-ru_fr-fr_es-es")
    if "%offlinelangc%"=="1" set "offlinelangc=" & set "lang1=%offlinelang:_=%" & goto :Lang1
    if "%A_lang%"=="" goto :Langch
    set "langc="
    for /f "tokens=1-5 delims=_+ " %%g in ("%A_lang%") do (
        set lang1=%%g
        set lang2=%%h
        set lang3=%%i
        set lang4=%%j
        set lang5=%%k)
    :Alang
    set /a langc+=1
    if "!lang%langc%!"=="" set /a langc-=1 & goto :eof
    call :lntolang !lang%langc%! lang!langc!
    call :langtoln !lang%langc%! ln!langc!
    call :lcid !lang%langc%! lcid!langc!
    if "!lcid%langc%!"=="0" set "A_lang=" & set "lang=" && echo Error&&pause&&goto :Lang
    echo %possiblelang% | find "!lang%langc%!" > nul || (set "A_lang=" & set "lang=" && echo Error&&pause&&goto :Lang)
    if %langc%==1 (set "lang=%lang1%" & set "ln=%ln1%") else (set "lang=%lang%_!lang%langc%!" & set "ln=%ln%+!ln%langc%!")
    goto :Alang
    :Langch
    if not "%offlinelang%"=="" (set "possiblelang=%offlinelang%") else (set "possiblelang=he-il_en-us_ru-ru_fr-fr_es-es") 
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang.
    echo Your system language is %lnos%.
    echo.
    echo Select language.
    set "c="
    set "choice="
    For %%k in ("he-il:Hebrew" "en-us:English" "ru-ru:Russian" "fr-fr:French" "es-es:Spanish") do for /f "tokens=1,2 delims=:" %%l in ("%%~k") do (
    if not "%possiblelang%"=="!possiblelang:%%l=!" (set /a c+=1 & set "langch!c!=%%l" & set "choice=!choice!!c!" & echo [ !c! ] %%m))
    set /a c+=1 & set "multilang=!c!" & set "choice=!choice!!c!" & echo [ !c! ] multiple languages
    echo.
    CHOICE /C %choice% /M "Enter your choice:"
    set "multilang=" & if "%ERRORLEVEL%"=="%multilang%" goto :multilang
    set "lang1=!langch%ERRORLEVEL%!"

    :Lang1
    set "langc=1"
    call :langtoln %lang1% ln1
    call :lcid %lang1% lcid1
    set "lang=%lang1%"
    set "ln=%ln1%"
    goto :eof
    
    :multilang
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang.
    echo Your system language is %lnos%.
    echo.
    echo Select the default language first.
    set "c="
    set "choice="
    For %%k in ("he-il:Hebrew" "en-us:English" "ru-ru:Russian" "fr-fr:French" "es-es:Spanish") do for /f "tokens=1,2 delims=:" %%l in ("%%~k")do (
    if not "%possiblelang%"=="!possiblelang:%%l=!" (set /a c+=1 & set "langch!c!=%%l" & set "choice=!choice!!c!" & echo [ !c! ] %%m))
    echo.
    CHOICE /C %choice% /M "Enter your choice:"
    set "lang1=!langch%ERRORLEVEL%!"
    set "langc=1"
    call :langtoln %lang1% ln1
    call :lcid %lang1% lcid1
    set "lang=%lang1%"
    set "ln=%ln1%"
    
    :multilang2
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang: %ln%
    echo Lang.
    echo Your system language is %lnos%.
    echo.
    echo Select the next language.
    set "c="
    set "choice="
    For %%k in ("he-il:Hebrew" "en-us:English" "ru-ru:Russian" "fr-fr:French" "es-es:Spanish") do for /f "tokens=1,2 delims=:" %%l in ("%%~k")do (
    if not "%possiblelang%"=="!possiblelang:%%l=!" (if "%lang%"=="!lang:%%l=!" (set /a c+=1 & set "langch!c!=%%l" & set "choice=!choice!!c!" & echo [ !c! ] %%m)))
    set /a c+=1 & set "choice=%choice%!c!" & set "save=!c!" & echo [ !c! ] continue with current languages set 
    echo.
    CHOICE /C %choice% /M "Enter your choice:"
    set "save=" & if %ERRORLEVEL%==%save% goto :eof
    set /a langc+=1 & set "lang!langc!=!langch%ERRORLEVEL%!"
    call :langtoln !lang%langc%! ln!langc!
    call :lcid !lang%langc%! lcid!langc!
    set "lang=%lang%_!lang%langc%!"
    set "ln=%ln%+!ln%langc%!"
    if %c%==2 goto :eof
    goto :multilang2
    
:lntolang
    if /i %1==English (set %2=en-us) else (if /i %1==E (set %2=en-us))
    if /i %1==Spanish (set %2=es-es) else (if /i %1==S (set %2=es-es))
    if /i %1==French (set %2=fr-fr) else (if /i %1==F (set %2=fr-fr))
    if /i %1==Hebrew (set %2=he-il) else (if /i %1==H (set %2=he-il))
    if /i %1==Russian (set %2=ru-ru) else (if /i %1==R (set %2=ru-ru))
    goto :eof
    
:langtoln
    set %2=%1
    if /i %1==en-us (set %2=English)
    if /i %1==es-es (set %2=Spanish)
    if /i %1==fr-fr (set %2=French)
    if /i %1==he-il (set %2=Hebrew)
    if /i %1==ru-ru (set %2=Russian)
    goto :eof
    
:lcid
    set %2=0
    if /i %1==en-us (set %2=1033)
    if /i %1==es-es (set %2=3082)
    if /i %1==fr-fr (set %2=1036)
    if /i %1==he-il (set %2=1037)
    if /i %1==ru-ru (set %2=1049)
    goto :eof
    
:product
    set "product=ProPlus2019Volume"
    if "%_365%"=="1" set "product=O365ProPlusRetail"
    if "%A_product%"=="" set "A_product=0"
    if not "%A_product%"=="%A_product:19=%" (set "product=ProPlus2019Volume" & set "_365=0")
    if not "%A_product%"=="%A_product:19Retail=%" set "product=%product:Volume=Retail%"
    if not "%A_product%"=="%A_product:Professional=%" set "product=%product:ProPlus=Professional%"
    if not "%A_product%"=="%A_product:HomeBusiness=%" set "product=%product:ProPlus=HomeBusiness%"
    if not "%A_product%"=="%A_product:HomeStudent=%" set "product=%product:ProPlus=HomeStudent%"
    if not "%A_product%"=="%A_product:365=%" (set "product=O365ProPlusRetail" & set "_365=1")
    if "%_365%"=="1" set "Teams1=teams,"
    goto :eof
    
:excludedapps
    set "Word=yes" & set "Word1=" & set "Word2=Word "
    set "Excel=yes" & set "Excel1=" & set "Excel2=Excel "
    set "PowerPoint=yes" & set "PowerPoint1=" & set "PowerPoint2=PowerPoint " 
    set "Access=yes" & set "Access1=" & set "Access2=Access "
    set "Outlook=yes" & set "Outlook1=" & set "Outlook2=Outlook "
    set "OneDrive=no" & set "OneDrive1=onedrive," & set "OneDrive2="
    set "OneNote=no" & set "OneNote1=onenote," & set "OneNote2="
    set "Publisher=no" & set "Publisher1=publisher," & set "Publisher2="
    set "Lync=no" & set "Lync1=lync," & set "Lync2="
    set "Groove=no" & set "Groove1=groove," & set "Groove2="
    set "VisioPro=no" & set "VisioPro1=" & set "VisioPro2=" & set "productvisio="
    set "ProjectPro=no" & set "ProjectPro1=" & set "ProjectPro2=" & set "productproject="

    :excludedapps1
    if "%A_exclude%"=="" goto :choice
    if not "%A_exclude%"=="%A_exclude:1=%" goto :excludedapps2
    if not "%A_exclude%"=="%A_exclude:0=%" goto :choice
    if not "%A_exclude%"=="%A_exclude:w=%" (set "Word=yes" & set "Word1=" & set "Word2=Word ") else (set "Word=no" & set "Word1=word," & set "Word2=")
    if not "%A_exclude%"=="%A_exclude:e=%" (set "Excel=yes" & set "Excel1=" & set "Excel2=Excel ") else (set "Excel=no" & set "Excel1=excel," & set "Excel2=")
    if not "%A_exclude%"=="%A_exclude:p=%" (set "Powerpoint=yes" & set "PowerPoint1=" & set "PowerPoint2=PowerPoint ") else (set "PowerPoint=no" & set "PowerPoint1=powerpoint," & set "PowerPoint2=")
    if not "%A_exclude%"=="%A_exclude:a=%" (set "Access=yes" & set "Access1=" & set "Access2=Access ") else (set "Access=no" & set "Access1=access," & set "Access2=")
    if not "%A_exclude%"=="%A_exclude:l=%" (set "Outlook=yes" & set "Outlook1=" & set "Outlook2=Outlook ") else (set "Outlook=no" & set "Outlook1=outlook," & set "Outlook2=")
    if not "%A_exclude%"=="%A_exclude:d=%" (set "OneDrive=yes" & set "OneDrive1=" & set "OneDrive2=OneDrive ") else (set "OneDrive=no" & set "OneDrive1=onedrive," & set "OneDrive2=")
    if not "%A_exclude%"=="%A_exclude:n=%" (set "OneNote=yes" & set "OneNote1=" & set "OneNote2=OneNote ") || (set "OneNote=no" & set "OneNote1=onenote," & set "OneNote2=")
    if not "%A_exclude%"=="%A_exclude:u=%" (set "Publisher=yes" & set "Publisher1=" & set "Publisher2=Publisher ") else (set "Publisher=no" & set "Publisher1=publisher," & set "Publisher2=")
    if not "%A_exclude%"=="%A_exclude:s=%" (set "lync=yes" & set "Lync1=" & set "Lync2='Skype for Business' ") else (set "Lync=no" & set "Lync1=lync," & set "Lync2=")
    if not "%A_exclude%"=="%A_exclude:o=%" (set "Groove=yes" & set "Groove1=" & set "Groove2='OneDrive for Business' ") else (set "Groove=no" & set "Groove1=groove," & set "Groove2=")
    if not "%A_exclude%"=="%A_exclude:v=%" (set "VisioPro=yes" & set "VisioPro1=|VisioPro2019Volume.16_%lang%_x-none^" & set "VisioPro2=Visio " & set "productvisio= VisioPro2019Volume") else (set "VisioPro=no" & set "VisioPro1=" & set "VisioPro2=" & set "productvisio=")
    if not "%A_exclude%"=="%A_exclude:r=%" (set "ProjectPro=yes" & set "ProjectPro1=|ProjectPro2019Volume.16_%lang%_x-none^" & set "ProjectPro2=Project " & set "productproject= ProjectPro2019Volume") else (set "ProjectPro=no" & set "ProjectPro1=" & set "ProjectPro2=" & set "productproject=")
    if not "%A_exclude%"=="%A_exclude:f=%" (set "Word=yes" & set "Word1=" & set "Word2=Word " & set "Excel=yes" & set "Excel1=" & set "Excel2=Excel " & set "Powerpoint=yes" & set "PowerPoint1=" & set "PowerPoint2=PowerPoint " & set "Access=yes" & set "Access1=" & set "Access2=Access " & set "Outlook=yes" & set "Outlook1=" & set "Outlook2=Outlook " & set "OneDrive=yes" & set "OneDrive1=" & set "OneDrive2=OneDrive " & set "OneNote=yes" & set "OneNote1=" & set "OneNote2=OneNote " & set "Publisher=yes" & set "Publisher1=" & set "Publisher2=Publisher " & set "lync=yes" & set "Lync1=" & set "Lync2='Skype for Business' " & set "Groove=yes" & set "Groove1=" & set "Groove2='OneDrive for Business' " & set "VisioPro=yes" & set "VisioPro1=|VisioPro2019Volume.16_%lang%_x-none^" & set "VisioPro2=Visio " & set "productvisio= VisioPro2019Volume" & set "ProjectPro=yes" & set "ProjectPro1=|ProjectPro2019Volume.16_%lang%_x-none^" & set "ProjectPro2=Project " & set "productproject= ProjectPro2019Volume")
   
    if "%_365%"=="1" (
        if not "!VisioPro1!"=="" (set "VisioPro1=!VisioPro1:2019Volume=Retail!" & set "productvisio=!productvisio:2019Volume=Retail!")
        if not "!ProjectPro1!"=="" (set "ProjectPro1=!ProjectPro1:2019Volume=Retail!" & set "productProject=!productProject:2019Volume=Retail!")
        )
    if not "%product%"=="%product:2019Retail=%" (
        if not "!VisioPro1!"=="" (set "VisioPro1=!VisioPro1:Volume=Retail!" & set "productvisio=!productvisio:Volume=Retail!")
        if not "!ProjectPro1!"=="" (set "ProjectPro1=!ProjectPro1:Volume=Retail!" & set "productProject=!productProject:Volume=Retail!")
        )
    if "%product%"=="%product:Pro=%" (
        if not "!VisioPro1!"=="" (set "VisioPro1=!VisioPro1:Pro=Std!" & set "productvisio=!productvisio:Pro=Std!")
        if not "!ProjectPro1!"=="" (set "ProjectPro1=!ProjectPro1:ectPro=ectStd!" & set "productProject=!productProject:ectPro=ectStd!")
        )
    goto :excludedapps2
    

    :choice
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang: %ln%
    echo Product: %product%%productvisio%%productproject%
    echo.
    echo Select apps to install.
    echo [ F ] All Office apps
    echo [ W ] Word                  : %Word%
    echo [ E ] Excel                 : %Excel%
    echo [ P ] PowerPoint            : %PowerPoint%
    echo [ A ] Access                : %Access%
    echo [ L ] OutLook               : %Outlook%
    echo [ D ] OneDrive              : %OneDrive%
    echo [ N ] OneNote               : %OneNote%
    echo [ U ] Publisher             : %Publisher%
    echo [ S ] Skype For Business    : %Lync%
    echo [ O ] OneDrive For Business : %Groove%
    echo [ V ] Visio                 : %VisioPro%
    echo [ R ] Project               : %ProjectPro%
    echo [ C ] Install with current set
    echo [ 1 ] Install Word, Excel, PowerPoint, Access ^& Outlook.
    echo.
    CHOICE /C FWEPALDNUSOVRC1 /M "Enter your choice:"
    if %ERRORLEVEL%==1 set "Word=yes" & set "Word1=" & set "Word2=Word " & set "Excel=yes" & set "Excel1=" & set "Excel2=Excel " & set "Powerpoint=yes" & set "PowerPoint1=" & set "PowerPoint2=PowerPoint " & set "Access=yes" & set "Access1=" & set "Access2=Access " & set "Outlook=yes" & set "Outlook1=" & set "Outlook2=Outlook " & set "OneDrive=yes" & set "OneDrive1=" & set "OneDrive2=OneDrive " & set "OneNote=yes" & set "OneNote1=" & set "OneNote2=OneNote " & set "Publisher=yes" & set "Publisher1=" & set "Publisher2=Publisher " & set "lync=yes" & set "Lync1=" & set "Lync2='Skype for Business' " & set "Groove=yes" & set "Groove1=" & set "Groove2='OneDrive for Business' " & set "VisioPro=yes" & set "VisioPro1=|VisioPro2019Volume.16_%lang%_x-none^" & set "VisioPro2=Visio " & set "productvisio= VisioPro2019Volume" & set "ProjectPro=yes" & set "ProjectPro1=|ProjectPro2019Volume.16_%lang%_x-none^" & set "ProjectPro2=Project " & set "productproject= ProjectPro2019Volume"
    if %ERRORLEVEL%==2 if %Word%==no (set "Word=yes" & set "Word1=" & set "Word2=Word ") else (set "Word=no" & set "Word1=word," & set "Word2=")
    if %ERRORLEVEL%==3 if %Excel%==no (set "Excel=yes" & set "Excel1=" & set "Excel2=Excel ") else (set "Excel=no" & set "Excel1=excel," & set "Excel2=")
    if %ERRORLEVEL%==4 if %PowerPoint%==no (set "Powerpoint=yes" & set "PowerPoint1=" & set "PowerPoint2=PowerPoint ") else (set "PowerPoint=no" & set "PowerPoint1=powerpoint," & set "PowerPoint2=")
    if %ERRORLEVEL%==5 if %Access%==no (set "Access=yes" & set "Access1=" & set "Access2=Access ") else (set "Access=no" & set "Access1=access," & set "Access2=")
    if %ERRORLEVEL%==6 if %Outlook%==no (set "Outlook=yes" & set "Outlook1=" & set "Outlook2=Outlook ") else (set "Outlook=no" & set "Outlook1=outlook," & set "Outlook2=")
    if %ERRORLEVEL%==7 if %OneDrive%==no (set "OneDrive=yes" & set "OneDrive1=" & set "OneDrive2=OneDrive ") else (set "OneDrive=no" & set "OneDrive1=onedrive," & set "OneDrive2=")
    if %ERRORLEVEL%==8 if %OneNote%==no (set "OneNote=yes" & set "OneNote1=" & set "OneNote2=OneNote ") else (set "OneNote=no" & set "OneNote1=onenote," & set "OneNote2=")
    if %ERRORLEVEL%==9 if %Publisher%==no (set "Publisher=yes" & set "Publisher1=" & set "Publisher2=Publisher ") else (set "Publisher=no" & set "Publisher1=publisher," & set "Publisher2=")
    if %ERRORLEVEL%==10 if %Lync%==no (set "lync=yes" & set "Lync1=" & set "Lync2='Skype for Business' ") else (set "Lync=no" & set "Lync1=lync," & set "Lync2=")
    if %ERRORLEVEL%==11 if %Groove%==no (set "Groove=yes" & set "Groove1=" & set "Groove2='OneDrive for Business' ") else (set "Groove=no" & set "Groove1=groove," & set "Groove2=")
    if %ERRORLEVEL%==12 if %VisioPro%==no (set "VisioPro=yes" & set "VisioPro1=|VisioPro2019Volume.16_%lang%_x-none^" & set "VisioPro2=Visio " & set "productvisio= VisioPro2019Volume") else (set "VisioPro=no" & set "VisioPro1=" & set "VisioPro2=" & set "productvisio=")
    if %ERRORLEVEL%==13 if %ProjectPro%==no (set "ProjectPro=yes" & set "ProjectPro1=|ProjectPro2019Volume.16_%lang%_x-none^" & set "ProjectPro2=Project " & set "productproject= ProjectPro2019Volume") else (set "ProjectPro=no" & set "ProjectPro1=" & set "ProjectPro2=" & set "productproject=")
    if "%_365%"=="1" (
        if not "!VisioPro1!"=="" (set "VisioPro1=!VisioPro1:2019Volume=Retail!" & set "productvisio=!productvisio:2019Volume=Retail!")
        if not "!ProjectPro1!"=="" (set "ProjectPro1=!ProjectPro1:2019Volume=Retail!" & set "productProject=!productProject:2019Volume=Retail!")
        )
    if not "%product%"=="%product:2019Retail=%" (
        if not "!VisioPro1!"=="" (set "VisioPro1=!VisioPro1:Volume=Retail!" & set "productvisio=!productvisio:Volume=Retail!")
        if not "!ProjectPro1!"=="" (set "ProjectPro1=!ProjectPro1:Volume=Retail!" & set "productProject=!productProject:Volume=Retail!")
        )
    if "%product%"=="%product:Pro=%" (
        if not "!VisioPro1!"=="" (set "VisioPro1=!VisioPro1:Pro=Std!" & set "productvisio=!productvisio:Pro=Std!")
        if not "!ProjectPro1!"=="" (set "ProjectPro1=!ProjectPro1:ectPro=ectStd!" & set "productProject=!productProject:ectPro=ectStd!")
        )
    if %ERRORLEVEL%==14 goto :excludedapps2
    if %ERRORLEVEL%==15 (
        set "Word=yes" & set "Word1=" & set "Word2=Word "
        set "Excel=yes" & set "Excel1=" & set "Excel2=Excel "
        set "PowerPoint=yes" & set "PowerPoint1=" & set "PowerPoint2=PowerPoint " 
        set "Access=yes" & set "Access1=" & set "Access2=Access "
        set "Outlook=yes" & set "Outlook1=" & set "Outlook2=Outlook "
        set "OneDrive=no" & set "OneDrive1=onedrive," & set "OneDrive2="
        set "OneNote=no" & set "OneNote1=onenote," & set "OneNote2="
        set "Publisher=no" & set "Publisher1=publisher," & set "Publisher2="
        set "Lync=no" & set "Lync1=lync," & set "Lync2="
        set "Groove=no" & set "Groove1=groove," & set "Groove2="
        set "VisioPro=no" & set "VisioPro1=" & set "VisioPro2=" & set "productvisio="
        set "ProjectPro=no" & set "ProjectPro1=" & set "ProjectPro2=" & set "productproject="
        goto :excludedapps2
        )
    goto :choice

    :excludedapps2
    if "%product%"=="%product:ProPlus=%" (
        set "Groove=no" & set "Groove1=" & set "Groove2=" & set "Lync=no" & set "Lync1=" & set "Lync2=" & if "%product%"=="%product:Professional=%" (
            set "Publisher=no" & set "Publisher1=" & set "Publisher2=" & set "Access=no" & set "Access1=" & set "Access2=" & if "%product%"=="%product:HomeBusiness=%" (
                set "Outlook=no" & set "Outlook1=" & set "Outlook2="
                )
            )
        )

    if not "%Word2%%Excel2%%PowerPoint2%%Access2%%Outlook2%%OneDrive2%%OneNote2%%Publisher2%%Lync2%%Groove2%%VisioPro2%%ProjectPro2%"=="" (set Included=Included Apps: %Word2%%Excel2%%PowerPoint2%%Access2%%Outlook2%%OneDrive2%%OneNote2%%Publisher2%%Lync2%%Groove2%%VisioPro2%%ProjectPro2%) else (set Included=All apps excluded )
    set Included=%Included:~0,-1%.
    if not "%Teams1%%Word1%%Excel1%%PowerPoint1%%Access1%%Outlook1%%OneDrive1%%OneNote1%%Publisher1%%Lync1%%Groove1%"=="" set "excludedapps=%product%.excludedapps=%Teams1%%Word1%%Excel1%%PowerPoint1%%Access1%%Outlook1%%OneDrive1%%OneNote1%%Publisher1%%Lync1%%Groove1%"
    if not "%excludedapps%"=="" set excludedapps=%excludedapps:~0,-1%
    if "%_365%"=="1" (
        if not "%projectpro1%"=="" (
            if not "%OneNote1%%Groove1%"=="" set "excludedappsProject=ProjectProRetail.excludedapps=%OneNote1%%Groove1%"
            if not "!excludedappsProject!"=="" set excludedappsProject=!excludedappsProject:~0,-1!
            )
        if not "%visiopro1%"=="" (
            if not "%OneNote1%%Groove1%"=="" set "excludedappsVisio=VisioProRetail.excludedapps=%OneNote1%%Groove1%"
            if not "!excludedappsVisio!"=="" set excludedappsVisio=!excludedappsVisio:~0,-1!
            )
         )
    goto :eof
    
:menugtr9
    set userinp=-
    set /p userinp=Enter your choice and press Enter: 
    if %userinp%==0 goto :menugtr9
    if %userinp%==- goto :menugtr9
    if %userinp% GTR %c% goto :menugtr9
    set "%1=!i_%1%userinp%!"
    goto :eof
    
:menulss10
    CHOICE /C %choice% /M "Enter your choice:"
    set "%1=!i_%1%ERRORLEVEL%!"
    goto :eof
    
:mondo
    if "%1"=="" goto :mondo3
    echo Detecting installation process
    :mondo1
    timeout 1 >nul
    wmic process where "Caption like 'OfficeClickToRun.exe'" get CommandLine /format:textvaluelist | find "O365" >nul || goto :mondo1
    echo Waiting for installation process to complete 
    :mondo2
    timeout 1
    wmic process where "Caption like 'OfficeClickToRun.exe'" get CommandLine /format:textvaluelist | find "O365" >nul && goto :mondo2
    :mondo3
    for /f "tokens=3* skip=1 delims= " %%l in ('reg query "HKCU\Software\Microsoft\Office\16.0\common\LanguageResources" /reg:%bitos% /v "UIFallbackLanguages"') do set uilang=%%l
    echo %uilang% | find /i "%lang1%" > nul || goto :eof
    :mondo4
    echo Adding Mondo license files...
    set "_Nul_1=1>nul"
    set "_Nul_2=2>nul"
    set "_Nul_2e=2^>nul"
    set "_Nul_1_2=1>nul 2>nul"
    for /f "tokens=6 delims=[]. " %%# in ('ver') do set winbuild=%%#
    if %winbuild% geq 9200 (
    set spp=SoftwareLicensingProduct
    set sps=SoftwareLicensingService
    ) else (
    set spp=OfficeSoftwareProtectionProduct
    set sps=OfficeSoftwareProtectionService
    )
    reg query HKLM\SOFTWARE\Microsoft\Office\ClickToRun /reg:%bitos% /v InstallPath %_Nul_1_2%
    for /f "skip=2 tokens=2*" %%a in ('"reg query HKLM\SOFTWARE\Microsoft\Office\ClickToRun /reg:%bitos% /v InstallPath" %_Nul_2e%') do if not errorlevel 1 (set "_InstallRoot=%%b\root")
    if "%_InstallRoot%" neq "" (
      for /f "skip=2 tokens=2*" %%a in ('"reg query HKLM\SOFTWARE\Microsoft\Office\ClickToRun /reg:%bitos% /v PackageGUID" %_Nul_2e%') do if not errorlevel 1 (set "_GUID=%%b")
      for /f "skip=2 tokens=2*" %%a in ('"reg query HKLM\SOFTWARE\Microsoft\Office\ClickToRun\Configuration /reg:%bitos% /v ProductReleaseIds" %_Nul_2e%') do if not errorlevel 1 (set "ProductIds=%%b")
      set "_Config=HKLM\SOFTWARE\Microsoft\Office\ClickToRun\Configuration"
      set "_PRIDs=HKLM\SOFTWARE\Microsoft\Office\ClickToRun\ProductReleaseIDs"
    ) else (
      for /f "skip=2 tokens=2*" %%a in ('"reg query HKLM\SOFTWARE\WOW6432Node\Microsoft\Office\ClickToRun /reg:%bitos% /v InstallPath" %_Nul_2e%') do if not errorlevel 1 (set "_InstallRoot=%%b\root")
      for /f "skip=2 tokens=2*" %%a in ('"reg query HKLM\SOFTWARE\WOW6432Node\Microsoft\Office\ClickToRun /reg:%bitos% /v PackageGUID" %_Nul_2e%') do if not errorlevel 1 (set "_GUID=%%b")
      for /f "skip=2 tokens=2*" %%a in ('"reg query HKLM\SOFTWARE\WOW6432Node\Microsoft\Office\ClickToRun\Configuration /reg:%bitos% /v ProductReleaseIds" %_Nul_2e%') do if not errorlevel 1 (set "ProductIds=%%b")
      set "_Config=HKLM\SOFTWARE\WOW6432Node\Microsoft\Office\ClickToRun\Configuration"
      set "_PRIDs=HKLM\SOFTWARE\WOW6432Node\Microsoft\Office\ClickToRun\ProductReleaseIDs"
    )
    
    set "_ID365=O365ProPlusRetail"
    set "_IDmondo=MondoVolume"
    set "_pkey=PidKey=DRNV7-VGMM2-B3G9T-4BF84-VMFTK"
    set "_LicensesPath=%_InstallRoot%\Licenses16"
    set "_Integrator=%_InstallRoot%\integration\integrator.exe"
    if not exist "!_Integrator!" goto :eof
    set "key=HFTND-W9MK4-8B7MJ-B6C4G-XQBR2"
    reg delete %_Config% /f /v %_ID365%.OSPPReady %_Nul_1_2%
    "!_Integrator!" /I /License PRIDName=%_ID365%.16 %_pkey% PackageGUID="%_GUID%" PackageRoot="!_InstallRoot!" %_Nul_1%
    reg add %_Config% /f /v %_ID365%.OSPPReady /t REG_SZ /d 1 %_Nul_1%
    reg add %_Config% /f /v ProductReleaseIds /t REG_SZ /d "%_ID365%" %_Nul_1%
    reg delete %_Config% /f /v %_IDmondo%.OSPPReady %_Nul_1_2%
    "!_Integrator!" /I /License PRIDName=%_IDmondo%.16 %_pkey% PackageGUID="%_GUID%" PackageRoot="!_InstallRoot!" %_Nul_1%
    reg add %_Config% /f /v %_IDmondo%.OSPPReady /t REG_SZ /d 1 %_Nul_1%
    reg add %_Config% /f /v ProductReleaseIds /t REG_SZ /d "%_ID365%,%_IDmondo%" %_Nul_1%
    for /f "tokens=2 delims==" %%# in ('"wmic path %sps% get version /value" %_Nul_2e%') do set ver=%%#
    wmic path %sps% where version='%ver%' call InstallProductKey ProductKey="%key%" %_Nul_1_2%
    goto :eof
    
:showmondo
    set check=wmic process where "Caption like 'cmd.exe'" get CommandLine /format:textvaluelist ^| find /i "mondo" ^>nul ^|^| goto :pw3
    call :PleaseWait "Adding Mondo license files, please wait"
    goto :eof
    
:Automode
    if /i "%1"=="d" set "Auto=Download"
    if /i "%1"=="n" set "Auto=Online" 
    if /i "%1"=="f" set "Auto=Offline"
    if /i "%1"=="download" set "Auto=Download"
    if /i "%1"=="online" set "Auto=Online" 
    if /i "%1"=="offline" set "Auto=Offline"
    set "A_ver=%2" & set "A_bit=%3" & set "A_lang=%4" & set "A_exclude=%5" & set "A_product=%6"
    if "%A_ver%"=="0" set "A_ver="
    if "%A_bit%"=="0" set "A_bit="
    if "%A_lang%"=="0" set "A_lang="
    if "%A_exclude%"=="0" set "A_exclude="
    goto :eof

:setarg
    set "args="
    if /i "%1"=="-h" call :help %2
    if /i "%1"=="-help" call :help %2
    if /i "%1"=="-m" if /i "%~2"=="d" set "args=2" & set "Auto=Download"
    if /i "%1"=="-m" if /i "%~2"=="n" set "args=2" & set "Auto=Online"
    if /i "%1"=="-m" if /i "%~2"=="f" set "args=2" & set "Auto=Offline"
    if /i "%1"=="-m" if /i "%~2"=="download" set "args=2" & set "Auto=Download"
    if /i "%1"=="-m" if /i "%~2"=="online" set "args=2" & set "Auto=Online"
    if /i "%1"=="-m" if /i "%~2"=="offline" set "args=2" & set "Auto=Offline"
    if /i "%1"=="-mode" if /i "%~2"=="d" set "args=2" & set "Auto=Download"
    if /i "%1"=="-mode" if /i "%~2"=="n" set "args=2" & set "Auto=Online"
    if /i "%1"=="-mode" if /i "%~2"=="f" set "args=2" & set "Auto=Offline"
    if /i "%1"=="-mode" if /i "%~2"=="download" set "args=2" & set "Auto=Download"
    if /i "%1"=="-mode" if /i "%~2"=="online" set "args=2" & set "Auto=Online"
    if /i "%1"=="-mode" if /i "%~2"=="offline" set "args=2" & set "Auto=Offline"
    if /i "%1"=="-v" set "args=2" & set "A_ver=%~2"
    if /i "%1"=="-ver" set "args=2" & set "A_ver=%~2"
    if /i "%1"=="-version" set "args=2" & set "A_ver=%~2"
    if /i "%1"=="-b" set "args=2" & set "A_bit=%~2"
    if /i "%1"=="-bit" set "args=2" & set "A_bit=%~2"
    if /i "%1"=="-l" set "args=2" & set "A_lang=%~2"
    if /i "%1"=="-lang" set "args=2" & set "A_lang=%~2"
    if /i "%1"=="-language" set "args=2" & set "A_lang=%~2"
    if /i "%1"=="-p" set "args=2" & set "A_product=%~2"
    if /i "%1"=="-product" set "args=2" & set "A_product=%~2"
    if /i "%1"=="-i" set "args=2" & set "A_exclude=%~2"
    if /i "%1"=="-include" set "args=2" & set "A_exclude=%~2"
    if /i "%1"=="-install" set "args=2" & set "A_exclude=%~2"
    goto :eof
    
:help
    cls
    echo.
    if not "%2"=="" goto :h%2 2>nul
    echo This is the list of arguments that you can use with the OfficeToolkit script.
    echo. 
    echo ex.: toolkit.bat -m n -version n -bit 32 -lang hebrew -include wepal
    echo.
    echo -------------------------------------------------------------------------------
    :h-m
    :h-mode
    echo Operation mode:
    echo    -mode,       ^| 'Online' or 'N' - Online installation 
    echo    -m           ^| 'Offline' or 'F' - Offline installation 
    echo    [N, Online   ^| 'Download' or 'D' - Download office files 
    echo     F, Offline  ^|                     for offline installation
    echo     D, Download]^| ex.: -m N, -mode Offline
    if not "%2"=="" goto :hEnd
    echo -------------------------------------------------------------------------------
    :h-v
    :h-ver
    :h-version
    echo Version:
    echo    -version,    ^| 'Newest' or 'N' - Newest version on server
    echo    -ver,        ^|                   (for online or download mode)
    echo    -v           ^| '#Number' - Number of downloaded version
    echo    [N, newest   ^|             1 for newest existing version,
    echo     #Number     ^|             For older versions, enter corresponding
    echo     #Version]   ^|             number (2 for 2nd to newest, 3 for 3rd, etc).
    echo                 ^|             If only one version exists, it will be selected 
    echo                 ^|             regardless of number you've entered.
    echo                 ^|             (for download or offline mode).
    echo                 ^| '#Version' - specific full version no.
    echo                 ^|              (for all operation modes)
    echo                 ^| ex.: -v 16.0.11328.20222 -version newest
    if not "%2"=="" goto :hEnd
    echo -------------------------------------------------------------------------------
    :h-b
    :h-bit
    echo Bit:
    echo    -bit,        ^| '32' or '1' - 32bit
    echo    -b           ^| '64' or '2' - 64bit
    echo    [32, 1       ^|
    echo     64, 2]      ^| ex.: -b 32, -bit 64  
    if not "%2"=="" goto :hEnd          
    echo -------------------------------------------------------------------------------
    :h-l
    :h-lang
    :h-language
    echo Language:
    echo    -language,   ^| The supported languages are English, Spanish, French,
    echo    -lang,       ^| Hebrew and Russian.
    echo    -l           ^| '#Name' - full language name or first letter of it
    echo    [#Name       ^| '#xx-xx' - localeID string (xx-xx).
    echo     #xx-xx]     ^| You can also enter multiple languages with _ or + seperator
    echo                 ^| ex.: -l he-il, -lang Hebrew+English
    if not "%2"=="" goto :hEnd
    echo -------------------------------------------------------------------------------
    :h-i
    :h-install
    :h-include
    echo Applications to install:
    echo    -include,    ^| The parameters and applications are: 'W'-Word, 'E'-Excel,
    echo    -install,    ^| 'P'-Powerpoint, 'A'-Access, 'L'-Outlook, 'D'-OneDrive,
    echo    -i           ^| 'N'-OneNote,'U'-Publisher, 'S'-Skype for business,
    echo    [#Letters]   ^| 'O'-OneDrive for business, 'V'-Visio, 'R'-Project.
    echo                 ^| 'F'-all apps. 'X'-exit without install (for download mode).
    echo                 ^| ex.: -i WEPALDNUSOVR, -install X
    if not "%2"=="" goto :hEnd
    echo -------------------------------------------------------------------------------
    :h-p
    :h-product
    echo Product:
    echo    -product,    ^| The parameters and products are:
    echo    -p,          ^| '365'-Office 365 ProPlus, '19'-Office 2019 ProPlus Volume,
    echo    [365,19      ^| 'Professional19'-Office 2019 Professional Volume,
    echo     #Product19  ^| 'HomeBusiness19'-Office 2019 Home ^& Business Volume,
    echo     19Retail]   ^| 'HomeStudent19'-Office 2019 Home ^& Student Volume,
    echo                 ^| '19Retail'-Office 2019 ProPlus Retail,
    echo                 ^| 'Professional19Retail'-Office 2019 Professional Retail,
    echo                 ^| 'HomeBusiness19Retail'-Office 2019 Home ^& Business Retail,
    echo                 ^| 'HomeStudent19Retail'-Office 2019 Home ^& Student Retail,
    echo                 ^| ex.: -p 365, -product 19 l, -p HomeStudent2019Retail
    :hEnd
    echo -------------------------------------------------------------------------------
    :h-h
    :h-help
    echo help:
    echo    -help, -h    ^| This help text.
    :hEnd
    echo -------------------------------------------------------------------------------
    echo All the arguments and parameters are NOT case sensitive.
    pause >NUL 2>&1 & set "args=x" & goto :eof
       
:aria2c
    if exist "%~dp0%files%\%1" goto :eof
    cls
    echo.
    echo ============================================================
    echo  %mode%
    echo ============================================================
    echo.
    echo Version: %ver%
    echo Bit: %bit%
    echo Lang: %ln%
    if not "%mode%"=="Download Office" (
        echo Product: %product%%productvisio%%productproject%
        echo %Included%
        )
    echo.
    echo Downloading files...
    if not exist "%temp%\aria2c.exe" (
        echo The start of download doesn't show progress, please wait.
        echo ^(New-Object System.Net.WebClient^).Downloadfile^('https://drive.google.com/uc?authuser=0^^^&id=1u6_jZ06y6d_BC1l7rFw_M6fWUfTeUQf8^^^&export=download','%temp%\aria2c.exe'^)|powershell -
        )
    "%temp%\aria2c.exe" %2 --summary-interval=0 -d "%~dp0%files%" %cdn%/%id%/Office/Data/%ver%/%1 2>nul
    goto :eof

:PleaseWait
    set setp_d=%setp2% & %delay%
    set setp_c=%setp2% & %check%
    set "msg=%~1" & shift /1
    :pw1
    if "%msg:~1,1%"==" " (
        set "msg=%msg:~2%" & set "cmsg=%msg:~0,2%"
        ) else (
        set "msg=%msg:~1%" & if "%msg:~1%"=="" (
            set "cmsg=%msg:~0,1% "
            ) else (
            set "cmsg=%msg:~0,1%"
            )
        )
    %setp1%%cmsg%%setp_d%
    if not "%msg%"=="" goto :pw1
    %setp1%/%setp_c%
    %setp1%%BS%%BS% - \%setp_c%
    %setp1%%BS%%BS%%BS%%BS% \ | /%setp_c%
    :pw2
    %setp1%%BS%%BS%%BS%%BS%%BS%%BS% | / -%setp_c%
    %setp1%%BS%%BS%%BS%%BS%%BS%%BS% / - \%setp_c%
    %setp1%%BS%%BS%%BS%%BS%%BS%%BS% - \ |%setp_c%
    %setp1%%BS%%BS%%BS%%BS%%BS%%BS% \ | /%setp_c%
    goto :pw2
    :pw3
    %setp1%%BS%!CR!%SPACES%!CR!%setp2%
    goto :eof


:waitFor
    set "sleepFor=%~1"
    call :currentTime startTime

    :loopStart
    call :currentTime curTime
    if %curTime% lss %startTime% set /a curTime+=86400000 
    set /a timeDiffMs=%curTime%-%startTime%
    if %timeDiffMs% GTR %sleepFor% goto :return
    set /a timeRemaining=%sleepFor%-%timeDiffMs%
    if %timeRemaining% GTR 1200 ( timeout /nobreak /t 1 >nul 2>&1 )
    goto :loopStart

    :return
    set "sleepFor="
    set "curTime="
    set "startTime="
    set "timeDiffMs="
    set "timeRemaining="
    goto :eof

    :currentTime
    set "curTime=%TIME%"
    if "%curTime:~0,1%"==" " set "curTime=0%curTime:~1%"
    set /a curTime=(1%curTime:~0,2%-100)*3600000 + (1%curTime:~3,2%-100)*60000 + (1%curTime:~6,2%-100)*1000 + (1%curTime:~9,2%-100)*10
    set %~1=%curTime%
    goto :eof


:Exit
    if exist "%temp%\aria2c.exe" del "%temp%\aria2c.exe" /f /q
    exit /b

----- Begin wsf script --->

<package>

    <job id="ADMIN"><script language="VBScript">
        Set UAC = CreateObject("Shell.Application") 
        args = "" 
        For Each strArg in WScript.Arguments
        args = args & strArg & " "  
        Next
        args = Replace( args , "chr(34)","""")
        UAC.ShellExecute "cmd.exe", args, "", "runas", 1 
    </script></job>

    <job id="HIDDEN"><script language="VBScript">
        Set UAC = CreateObject("Shell.Application") 
        args = "" 
        For Each strArg in WScript.Arguments
        args = args & strArg & " "  
        Next
        args = Replace( args , "chr(34)","""")
        UAC.ShellExecute "cmd.exe", args, "", "", 0 
    </script></job>

</package>